VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMoveList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'/*
' * Copyright 1999-2004 by Michel D. Grimminck
' *
' * All Rights Reserved
' *
' * Permission to use, copy, modify, and distribute this software and its
' * documentation for any purpose and without fee is hereby granted,
' * provided that the above copyright notice appear in all copies and that
' * both that copyright notice and this permission notice appear in
' * supporting documentation.
' *
' * This program is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
' *
' * Please read GPL.html for the full license text.
' */


Private myMoveList() As Long
Private moveIndex() As Long
Dim board(MAXDIST1) As Integer
Private boardOrder() As Long
Dim boardCount As Long
Dim tmpEtable As New clsEquityTable
Dim ccount
Dim wCount As Long
Dim curSize As Long
Public tableSize As Long
Public Property Get xMoveList(Index As Long) As Long
    xMoveList = myMoveList(Index)
End Property
Public Property Get xMoveIndex(Index As Long) As Long
    xMoveIndex = moveIndex(Index)
End Property
Public Property Get xboardOrder(Index As Long) As Long
    xboardOrder = boardOrder(Index)
End Property

Public Sub init(ccount As Integer)
    checkCount = ccount
End Sub
Public Sub createList(MAXDIST As Integer, checkerCount As Integer)
    wCount = 0
#If DEMO Then
    If MAXDIST = 6 And 2 * checkerCount > 10 Then Exit Sub
#End If
    showDebug ("Creating movelist for " & checkerCount & " checkers")
    Call tmpEtable.init(MAXDIST, checkerCount, 0)
    ReDim Preserve moveIndex(21 * tmpEtable.tableSize)
    ReDim boardOrder(tmpEtable.tableSize)
    tableSize = tmpEtable.tableSize
    showDebug ("Number of entries: " & tmpEtable.tableSize & ", size of index: " & showBytes(tmpEtable.tableSize * 21 * 4))
    curSize = 0
    boardCount = 0
    ccount = checkerCount
    movesMaxDist = MAXDIST
    
    'ppp For pips = 1 To MAXDIST * checkerCount
        'ppp Debug.Print "pips", pips
        'Debug.Print "board", pboard
        For i = 1 To MAXDIST: board(i) = 0: Next
        Call enumerate(1, MAXDIST, checkerCount, pips)
    'ppp Next
    showDebug ("Movelist entries: " & wCount & ", size: " & showBytes(wCount * 4 + tmpEtable.tableSize * 21 * 4))
End Sub
Public Sub enumerate(distance, maxdistance, checkerCount, pips)
    ' precompute the movelist
    '
    Dim d1 As Integer
    Dim d2 As Integer
    Dim cntNr As Integer
    Dim pip As Integer
    Dim bb(7) As Integer
    Dim cnt As Long
    If distance >= maxdistance Then
        board(distance) = checkerCount
        pip = 0: cnt = 0
        For i = 1 To MAXDIST
            pip = pip + board(i) * i
            cnt = cnt + board(i)
        Next
        For i = 1 To 6: bb(i) = board(i): Next
        'nr = etables(6, 0, cnt).boardNr(bb(), 4, cnt)
        'ppp If pip <> pips Then Exit Sub
        'Debug.Print pboard, nr
        'etables(maxdistance, CCbottom, CCtop).equity(board(), topb()) = eq
        basenr = tmpEtable.boardNrBottom(board())
        boardOrder(boardCount) = basenr
        boardCount = boardCount + 1
        'showDebug (nr)
        'showDebug (pboard)
        'Debug.Print pboard
        For i = 1 To MAXDIST: cBoard(i) = board(i): Next
        cntNr = 0
        For d1 = 1 To 6: For d2 = 1 To d1
            Call clearMoveList
            Call doAllMoves(d1, d2)
            'If d1 = d2 Then Debug.Print cntNr
            nr = 21 * basenr + cntNr: cntNr = cntNr + 1
            moveIndex(nr) = wCount
'           Debug.Print wCount
            If (wCount + moveListCount + 1) >= curSize Then curSize = curSize + 5000: ReDim Preserve myMoveList(curSize): DoEvents
            For i = 0 To moveListCount - 1
                myMoveList(wCount + i) = moveList(i)
            Next
            myMoveList(wCount + i) = -1
            wCount = wCount + moveListCount + 1
        Next: Next
'        For d1 = 1 To 6
'            Call clearMoveList
'            Call doAllMoves(d1, d1)
'            nr = 36 * basenr + 6 * d1 + d2 - 7
'            moveIndex(nr) = wCount
'
'            If (wCount + moveListCount + 1) >= curSize Then curSize = curSize + 5000: ReDim Preserve moveList(curSize)
'            For i = 0 To moveListCount - 1
'                moveList(wCount + i) = moveList(i)
'            Next
'            moveList(wCount + i) = -1
'            wCount = wCount + moveListCount + 1
'        Next
        'frmSolve.Caption = wcount: DoEvents
        Exit Sub
    End If
    For i = checkerCount To 0 Step -1
        board(distance) = i
        Call enumerate(distance + 1, maxdistance, checkerCount - i, pips)
    Next
End Sub

Function pboard()
    Dim pip As Long
    pip = 0
    For i = 1 To MAXDIST
        pboard = pboard & board(i)
        pip = pip + board(i) * i
        If i = 6 Then pboard = pboard & " "
    Next
    pboard = pboard & "   " & pip
End Function

