Attribute VB_Name = "Module1"
'/*
' * Copyright 1999-2004 by Michel D. Grimminck
' *
' * All Rights Reserved
' *
' * Permission to use, copy, modify, and distribute this software and its
' * documentation for any purpose and without fee is hereby granted,
' * provided that the above copyright notice appear in all copies and that
' * both that copyright notice and this permission notice appear in
' * supporting documentation.
' *
' * This program is distributed in the hope that it will be useful,
' * but WITHOUT ANY WARRANTY; without even the implied warranty of
' * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
' *
' * Please read GPL.html for the full license text.
' */


Public Const MAXDIST = 6
Public Const MAXDIST1 = 7

Public etables(6, 15, 15) As New clsEquityTable
Public gCount As Long
Public mCount As Long
Dim board(24)

Dim countc(25, 15) As Double
Dim a
Declare Function ShellExecute Lib _
    "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, _
    ByVal lpOperation As String, ByVal lpfile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long
Public Declare Function MakeSureDirectoryPathExists Lib "IMAGEHLP.dll" (ByVal dirpath As String) As Long

Public Sub test()
    board(3) = 2
    'Debug.Print nrb(board(), 3, 2)
    Debug.Print countb(3, 2)
End Sub
Public Function position(b())
    Dim total As Integer
    For i = 1 To MAXDIST
        If b(i) > 0 Then dist = i
        total = total + b(i)
    Next
    position = nrb(b(), dist, total)
End Function

Public Function nrb(b(), dist, total)
    If dist = 1 Or total = 0 Then nrb = 0: Exit Function
    If b(dist) = 0 Then nrb = nrb(b, dist - 1, total): Exit Function
    
    nrb = nrb(b(), dist - 1, total - b(dist))
    For i = 0 To b(dist) - 1
        nrb = nrb + countb(dist - 1, total - i)
    Next
End Function
Public Function countb(dist, total) As Double
    If dist = 1 Or total = 0 Then countb = 1: Exit Function
    If countc(dist, total) <> 0 Then countb = countc(dist, total): Exit Function
    a = a + 1:
    countb = 0
    For i = 0 To total
        countb = countb + countb(dist - 1, total - i)
    Next
    countc(dist, total) = countb
End Function

Public Sub enumerateBottom(board() As Integer, topb() As Integer, distance, maxdistance, checkerCount, CCbottom, CCtop)

    If distance >= maxdistance Then
        board(distance) = checkerCount
        Call enumerateTop(board(), topb(), 1, maxdistance, CCtop, CCbottom, CCtop)
        Exit Sub
    End If
    For i = checkerCount To 0 Step -1
        board(distance) = i
        Call enumerateBottom(board(), topb(), distance + 1, maxdistance, checkerCount - i, CCbottom, CCtop)
    Next
End Sub
Public Sub enumerateTop(board() As Integer, topb() As Integer, distance, maxdistance, checkerCount, CCbottom, CCtop)

    If distance >= maxdistance Then
        topb(distance) = checkerCount
        
        For i = 1 To MAXDIST: cBoard(i) = topb(i): Next
      '  eq = computeEquity(board(), topb())
        etables(maxdistance, CCbottom, CCtop).equity(board(), topb(), 0) = eq
        gCount = gCount + 1
        If gCount Mod 100 = 0 Then frmSolve.Caption = gCount & " " & mCount: frmSolve.List1.Visible = True: DoEvents: frmSolve.List1.Visible = False
        frmSolve.List1.AddItem pboard & " eq. " & eq
        'frmSolve.Caption = frmSolve.List1.ListCount
        
        Exit Sub
    End If
    For i = checkerCount To 0 Step -1
        topb(distance) = i
        Call enumerateTop(board(), topb(), distance + 1, maxdistance, checkerCount - i, CCbottom, CCtop)
    Next
End Sub
#If dsa = 324 Then
Private Function computeEquity(board() As Integer, topb() As Integer) As Single
    ' do all moves
    ce = 0
    ' single trows
    Dim d1 As Integer
    Dim d2 As Integer
    For i = 1 To MAXDIST: cBoard(i) = topb(i): Next
    For d1 = 1 To 6: For d2 = d1 + 1 To 6
        'If Left$(pboard, 2) = "11" Then
        '    b = 4
        'End If
        'frmSolve.List1.AddItem "-" & d1 & " " & d2
        'frmSolve.List1.ListIndex = frmSolve.List1.ListCount - 1
        Call doAllMoves(d1, d2)
        ce = ce + gScore / 18#
    Next: Next
    For d1 = 1 To 6
      '  For i = 1 To MAXDIST: cBoard(i) = topb(i): Next
        'If Left$(pboard, 2) = "11" Then
        '    b = 4
        'End If
        'frmSolve.List1.AddItem "-" & d1 & " " & d2
        'frmSolve.List1.ListIndex = frmSolve.List1.ListCount - 1
        Call doAllMoves(d1, d1)
        ce = ce + gScore / 36#
    Next
    computeEquity = ce + 1
    Exit Function
        If gCount Mod 1 = 0 Then
            For i = 1 To 6: frmSolve.bottom(i - 1) = board(i): Next
            For i = 1 To 6: frmSolve.topc(i - 1) = topb(i): Next
            DoEvents
        End If
        gCount = gCount + 1
End Function
#End If
Public Sub showDebug(value)
    frmSolve.List1.AddItem (value)
    frmSolve.List1.ListIndex = frmSolve.List1.ListCount - 1
    DoEvents
End Sub
Public Function minZero(value)
    If value < 0 Then
        minZero = 0
    Else
        minZero = value
    End If
End Function

Public Sub Main()
    For d = 1 To 6
        For i = 0 To 15: For j = 0 To 15
            Call etables(d, i, j).init(d, i, j)
            If d = 6 Or d = 4 Then Call etables(d, i, j).initfile(App.Path & "\bod\1-" & d & "-" & i & "-" & j & ".bod")
        Next: Next
    Next
End Sub
Public Function showBytes(b As Double) As String
    If b < 1024# Then showBytes = b & " bytes": Exit Function
    If b < 1024# * 1024# Then showBytes = Format(b / 1024, "#0.0") & " Kb.": Exit Function
    If b < 1024# * 1024# * 1024# Then showBytes = Format(b / 1024# / 1024#, "#0.0") & " Mb.": Exit Function
    showBytes = Format(b / 1024# / 1024# / 1024#, "#0.0") & " Gb."
End Function

