VERSION 5.00
Begin VB.Form frmTest 
   Caption         =   "Form1"
   ClientHeight    =   2505
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3750
   LinkTopic       =   "Form1"
   ScaleHeight     =   2505
   ScaleWidth      =   3750
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim cBoard(MAXDIST1) As Integer

Private Sub Form_Load()
    
    Call initboard
    Debug.Print "Starting"
    Debug.Print pboard()
    Debug.Print
    Call doAllMoves(6, 5)
End Sub
Sub initboard()
    cBoard(1) = 2
    cBoard(2) = 2
    cBoard(3) = 0
    cBoard(4) = 2
    cBoard(5) = 2
    cBoard(6) = 2
End Sub
Function pboard()
    Dim pip As Long
    pip = 0
    For i = 1 To MAXDIST
        pboard = pboard & cBoard(i)
        pip = pip + cBoard(i) * i
        If i = 6 Then pboard = pboard & " "
    Next
    pboard = pboard & "   " & pip
End Function
Sub doAllMoves(d1, d2)
    If d1 = d2 Then Call doDoubleMoves(d1): Exit Sub
    Call doSingleMoves(d1, d2)
    Call doSingleMoves(d2, d1)
End Sub
Sub doSingleMoves(d1, d2)
    Dim t1(MAXDIST1) As Integer
    Dim t2(MAXDIST1) As Integer
    For i = 1 To MAXDIST: t1(i) = cBoard(i): Next
    For i1 = 1 To MAXDIST
        If cBoard(i1) > 0 Then
            If tryMove(i1, d1) Then
                secondMove = False
                For i = 1 To MAXDIST: t2(i) = cBoard(i): Next
                For i2 = 1 To MAXDIST
                    If cBoard(i2) > 0 Then
                        If tryMove(i2, d2) Then
                            Debug.Print pboard()
                            secondMove = True
                        End If
                        For i = 1 To MAXDIST: cBoard(i) = t2(i): Next
                    End If
                Next
                If Not secondMove Then 'apperantly only one checker can be moved
                    Debug.Print pboard()
                End If
            End If
            For i = 1 To MAXDIST: cBoard(i) = t1(i): Next
        End If
    Next
End Sub
Sub doDoubleMoves(d1)
    Dim t1(MAXDIST1) As Integer
    Dim t2(MAXDIST1) As Integer
    Dim t3(MAXDIST1) As Integer
    Dim t4(MAXDIST1) As Integer
    For i = 1 To MAXDIST: t1(i) = cBoard(i): Next
    For i1 = 1 To MAXDIST
        If cBoard(i1) > 0 Then
            If tryMove(i1, d1) Then
                secondMove = False
                For i = 1 To MAXDIST: t2(i) = cBoard(i): Next
                For i2 = 1 To MAXDIST
                    If cBoard(i2) > 0 Then
                        If tryMove(i2, d1) Then
                            secondMove = True
                            'third checker
                            thirdMove = False
                            For i = 1 To MAXDIST: t3(i) = cBoard(i): Next
                            For i3 = 1 To MAXDIST
                                If cBoard(i3) > 0 Then
                                    If tryMove(i3, d1) Then
                                        fourthMove = False
                                        For i = 1 To MAXDIST: t4(i) = cBoard(i): Next
                                        For i4 = 1 To MAXDIST
                                            If cBoard(i4) > 0 Then
                                                If tryMove(i4, d1) Then
                                                    Debug.Print "x" & pboard()
                                                    For i = 1 To MAXDIST: cBoard(i) = t4(i): Next
                                                    fourthMove = True
                                                End If
                                            End If
                                        Next
                                        'Debug.Print pboard()
                                        thirdMove = True
                                        If Not fourthMove Then
                                            Debug.Print "f" & pboard()
                                        End If
                                        For i = 1 To MAXDIST: cBoard(i) = t3(i): Next
                                    End If
                                End If
                            Next
                            secondMove = True
                            If Not thirdMove Then
                                Debug.Print "t" & pboard()
                            End If
                            For i = 1 To MAXDIST: cBoard(i) = t2(i): Next
                        End If
                    End If
                Next
                If Not secondMove Then 'apperantly only one checker can be moved
                    Debug.Print "s" & pboard()
                End If
                For i = 1 To MAXDIST: cBoard(i) = t1(i): Next
            End If
        End If
    Next
End Sub
Function tryMove(point, dice) As Boolean
    tryMove = False
    If point > dice Then 'no bear off
        cBoard(point) = cBoard(point) - 1
        cBoard(point - dice) = cBoard(point - dice) + 1
        tryMove = True
    ElseIf point = dice Then ' normal bear off
        cBoard(point) = cBoard(point) - 1
        tryMove = True
    Else ' bear off if no higher point occupied
        hasHigher = False
        For k = point + 1 To MAXDIST
            If cBoard(k) > 0 Then hasHigher = True
        Next
        If Not hasHigher Then cBoard(point) = cBoard(point) - 1: tryMove = True
    End If
End Function
